org.apache.sysds.runtime.functionobjects

## Class CM

- java.lang.Object
- - org.apache.sysds.runtime.functionobjects.FunctionObject
  - - org.apache.sysds.runtime.functionobjects.ValueFunction
    - - org.apache.sysds.runtime.functionobjects.CM

All Implemented Interfaces:
  Serializable

    public class CM
    extends ValueFunction

GENERAL NOTE: * 05/28/2014: We decided to do handle weights consistently to SPSS in an operation-specific manner, i.e., we (1) round instead of casting where required (e.g. count), and (2) consistently use fractional weight values elsewhere. In case a count-base interpretation of weights is needed, just ensure rounding before calling CM/COV/KahanPlus.

See Also:
  Serialized Form

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`Data` `execute(Data in1, Data in2)` Combining stats from two partitions of the data.
`Data` `execute(Data in1, double in2)` Special case for weights w2==1
`Data` `execute(Data in1, double in2, double w2)` General case for arbitrary weights w2
`CMOperator.AggregateOperationTypes` `getAggOpType()`
`static CM` `getCMFnObject(CMOperator.AggregateOperationTypes type)`

### Methods inherited from class org.apache.sysds.runtime.functionobjects.ValueFunction

`requiresCorrection`

### Methods inherited from class org.apache.sysds.runtime.functionobjects.FunctionObject

`clone, execute, execute, execute, execute, execute, execute, execute, execute, execute`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### getCMFnObject

    public static CM getCMFnObject(CMOperator.AggregateOperationTypes type)

#### getAggOpType

    public CMOperator.AggregateOperationTypes getAggOpType()

#### execute

    public Data execute(Data in1,
                        double in2)

Special case for weights w2==1

Overrides:
  `execute` in class `FunctionObject`

#### execute

    public Data execute(Data in1,
                        double in2,
                        double w2)

General case for arbitrary weights w2

Overrides:
  `execute` in class `FunctionObject`

#### execute

    public Data execute(Data in1,
                        Data in2)

Combining stats from two partitions of the data.

Overrides:
  `execute` in class `FunctionObject`